//
// Programma che utilizza la classe Dipendenti, Impiegati e Manager.
// Seconda versione.
//

#include <iostream.h>

#include "Impiegati2.H"


main()
{
  Dipendente *dipendente[100];

  // Un certo numero di Impiegati
  Impiegato A("Pippo", "Spedizioni", 27);
  Impiegato B("Pluto", "Sorveglianza", 19);
  Impiegato C("Minni", "Segreteria", 23);
  Impiegato D("Topolino", "Segreteria", 35);
  Impiegato E("Clarabella", "Portineria", 31);

  // Ed un paio di Manager
  Manager M("Paperone", 9, 62);
  Manager N("Rockerduck", 8, 47);

  // Registriamo tutti i dipendenti
  dipendente[0] = &A;
  dipendente[1] = &B;
  dipendente[2] = &C;
  dipendente[3] = &D;
  dipendente[4] = &E;
  dipendente[5] = &M;
  dipendente[6] = &N;
  dipendente[7] = new Impiegato("Archimede", "Tecnico", 37);
  Impiegato *pF = new Impiegato("Paperoga", "Pulizie", 26);
  Manager *pO = new Manager("CuorDiPietra", 7, 55);
  dipendente[8] = pF;
  dipendente[9] = pO;



  // Alcuni dipendenti hanno un salario diverso da quello standard
  A.SetSalario(1200000);
  E.SetSalario(1400000);
  dipendente[2]->SetSalario(1800000);
  dipendente[8]->SetSalario(1100000);

  M.SetSalario(200000000);
  // Il gruppo di lavoro del primo Manager
  M.AddToGrp(&D);
  M.AddToGrp(&C);
  M.AddToGrp(&E);

  // Il gruppo di lavoro del secondo Manager
  N.AddToGrp(&A);
  N.AddToGrp(&B);

  dipendente[9]->SetSalario(100000000);
  // Il gruppo di lavoro del terzo Manager
  pO->AddToGrp(dipendente[8]);	// N.B.: devo usare un puntatore a Manager
				// visto che AddToGrp non e` virtuale

  // Un Manager puo` dipendere da un'altro
  // N.AddToGrp(pO);

  // Stampiamo la lista dei dipendenti
  cout << "Lista Dipendenti: " << endl;
  cout << "----------------" << endl;
  for (int i = 0; i < 10; i++) {
    cout << "Record " << i << endl;
    dipendente[i]->Print();
    cout << "----------------" << endl;
  }

  // E tutti lavorano!
  cout << "Ogni giorno lavorativo: " << endl;
  cout << "!!!!!!!!!!!!!!!!" << endl;
  for (int i = 0; i < 10; i++)
    dipendente[i]->Lavora();

  cout << "!!!!!!!!!!!!!!!!" << endl;


  delete dipendente[7];
  delete dipendente[8];
  delete dipendente[9];

  exit(0);
}
